<?php

class Access
{
    const RIGHTS_AUTHORIZED = -2;  // no guests
    const RIGHTS_ANYBODY = 1;      // guests too
    const RIGHTS_STUDENT = 2;
    const RIGHTS_TEACHER = 4;
    const RIGHTS_ADMIN = 8;
    const RIGHTS_DEAN = 16;

    protected $roleMark;

    public function __construct($userRole) {
        $this->roleMark = $userRole? $userRole: (int)1;
    }

    public static function instance($userRole) {
        return new self( $userRole );
    }

    /**
     * @param $mask
     * @throws LogicException
     */
    public function checkAccess($pageMask) {
        $goodBoy = $this->roleMark & $pageMask;
        if (!$goodBoy) throw new LogicException(Error::ACCESS_DENIED);
    }

    public function checkGrant($pageMask) {
        return ($this->roleMark & $pageMask) !== 0;
    }

    public function isDean() {
        return (bool) ($this->roleMark & self::RIGHTS_DEAN);
    }

    public function isAdmin() {
        return (bool) ($this->roleMark & self::RIGHTS_ADMIN);
    }

    public function isTeacher() {
        return (bool) ($this->roleMark & self::RIGHTS_TEACHER);
    }

    public function isStudent() {
        return (bool) ($this->roleMark & self::RIGHTS_DEAN);
    }

    public function isAuthorized() {
        return (bool) ($this->roleMark & ~self::RIGHTS_ANYBODY);
    }

}