<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Handler_Map extends Controller_Handler {

		/** @var  Model_Map */
		protected $model;


        public function before() {
            parent::before();

            $role = $this->user->RoleMark;
			Access::instance($role)->checkAccess(Access::RIGHTS_TEACHER);
            $this->model = new Model_Map;
        }
    
        
		private function privateDeleteSubmodule($SubmoduleID) {
			$result = $this->model->deleteSubmodule($this->user->TeacherID, $SubmoduleID);
			return $result[0]['Num'];
		}

	// --- Изменения базовых параметров дисциплины ---
	
		// Изменение предмета
		public function action_ChangeDisciplineSubject() {
			$data['success'] = false;
            $this->post -> rule('DisciplineID', 'not_empty')
                        -> rule('DisciplineID', 'digit')
						-> rule('SubjectID', 'not_empty')
                        -> rule('SubjectID', 'digit');
			if($this->post->check()) {
				$result = $this->model->ChangeDisciplineSubject(
					$this->user->TeacherID,
					$this->post['DisciplineID'],
					$this->post['SubjectID']
				);
				if ($result[0]['Num'] == 0)
					$data['success'] = true;
			}
			$this->response->body(json_encode($data));
		}
		
		// Изменение статуса бонусного модуля
		public function action_ChangeStatusBonusModule() {
			$data['success'] = false;
            $this->post -> rule('DisciplineID', 'not_empty')
                        -> rule('DisciplineID', 'digit')
						-> rule('BonusRate', 'not_empty');
			if($this->post->check()) {
				if ($this->post['BonusRate'] == 'true') {
					$result = $this->model->AddModuleBonus(
						$this->user->TeacherID,
						$this->post['DisciplineID']
					);
					$data['action'] = 'add';
				}
				else {
					$result = $this->model->DeleteModuleBonus(
						$this->user->TeacherID,
						$this->post['DisciplineID']
					);
					$data['action'] = 'delete';
				}
				if ($result[0]['Num'] == 0)
					$data['success'] = true;
			}
			$this->response->body(json_encode($data));
		}
		
		// Изменение курса
		public function action_ChangeDisciplineGrade() {
			$data['success'] = false;
            $this->post -> rule('DisciplineID', 'not_empty')
                        -> rule('DisciplineID', 'digit')
                        -> rule('SubjectID', 'not_empty')
                        -> rule('SubjectID', 'digit')
						-> rule('GradeID', 'not_empty')
                        -> rule('GradeID', 'digit');

			if($this->post->check()) {
				$result = Model_Discipline::changeGrade(
                    $this->post['DisciplineID'],
					$this->user->TeacherID,
					$this->post['GradeID']
				);
				if ($result[0]['Num'] == 0)
					$data['success'] = true;
			}
			$this->response->body(json_encode($data));
		}
		
		// Изменение контроля
		public function action_ChangeDisciplineControl() {
            $this->post -> rule('DisciplineID', 'not_empty')
                        -> rule('DisciplineID', 'digit')
						-> rule('Control', 'not_empty');
			if($this->post->check()) {
				$result = $this->model->ChangeDisciplineControl(
					$this->user->TeacherID,
					$this->post['DisciplineID'],
					$this->post['Control']
				);
				$data['success'] = $result[0]['Num'];
			}
			else
				$data['success'] = 0;
			$this->response->body(json_encode($data));
		}
		
		// Изменение лекционных часов и практических часов
		public function action_ChangeDisciplineHours() {
			$data['success'] = false;
            $this->post -> rule('DisciplineID', 'not_empty')
                        -> rule('DisciplineID', 'digit')
						-> rule('Hours', 'not_empty')
                        -> rule('Hours', 'digit')
						-> rule('Type', 'not_empty')
                        -> rule('Type', 'digit');
			if($this->post->check()) {
				$result = $this->model->ChangeDisciplineHours(
					$this->user->TeacherID,
					$this->post['DisciplineID'],
					$this->post['Hours'],
					$this->post['Type']
				);
				if ($result[0]['Num'] == 0)
					$data['success'] = true;
			}
			$this->response->body(json_encode($data));
		}
		
	// ----------------
		
		// Список предметов по первым буквам
		public function action_GetSubjectsList()
		{
			$data['success'] = false;
            $this->post -> rule('FacultyID', 'not_empty')
                        -> rule('FacultyID', 'digit');
            if($this->post->check()) {
                $faculty = Model_Faculty::with($this->post['FacultyID']);
				$subjectsList = $faculty->getSubjects();
				$data['success'] = true;
			}
			$this->response->body(json_encode($subjectsList));
		}
		
		// Добавить модуль и к модулю 1 мероприятие
		public function action_AddModule() {
			$data['success'] = false;
            $this->post -> rule('DisciplineID', 'not_empty')
                        -> rule('DisciplineID', 'digit');
            if($this->post->check()) {
				// Добавление модуля
                $result = $this->model->AddModule(
					$this->user->TeacherID,
					$this->post['DisciplineID'],
					''
				);
				$data['moduleID'] = $result[0]['Num'];
				if ($data['moduleID'] > 0) {
					// Добавление мероприятия
					// Т.к. модуль должен содержать хотя бы
					// 1 мероприятие
					$result = $this->model->AddSubmodule(
						$this->user->TeacherID,
						$data['moduleID'],
						'0', //MaxRate
						'',
						'', //Description
						'CurrentControl'
					);
					$data['submoduleID'] = $result[0]['Num'];
					if ($data['submoduleID'] > 0)
						$data['success'] = true;
				}
					
            }
			$this->response->body(json_encode($data));
		}
		
		// Добавление мероприятия
		public function action_AddSubmodule() {
			$data['success'] = false;
            $this->post -> rule('submoduleID', 'not_empty')
                        -> rule('submoduleID', 'digit');
            if($this->post->check()) {
					$result = $this->model->AddSubmodule(
						$this->user->TeacherID,
						$this->post['submoduleID'],
						'0', //MaxRate
						'',
						'', //Description
						'CurrentControl'
					);
					$data['submoduleID'] = $result[0]['Num'];
					if ($data['submoduleID'] > 0)
						$data['success'] = true;
			}
			$this->response->body(json_encode($data));
		}
		
		// Поменять имя модуля
		public function action_ChangeModuleName() {
			$data['success'] = false;
            $this->post -> rule('ModuleID', 'not_empty')
                        -> rule('ModuleID', 'digit')
						-> rule('ModuleName', 'not_empty');
            if($this->post->check()) {
                $result = $this->model->ChangeModuleName($this->user->TeacherID, $this->post['ModuleID'], $this->post['ModuleName']);
				if ($result[0]['Num'] == 0)
					$data['success'] = true;
			}
			$this->response->body(json_encode($data));
		}
		
		// Поменять имя мероприятия
		public function action_ChangeSubmoduleName() {
			$data['success'] = false;
            $this->post -> rule('SubmoduleID', 'not_empty')
                        -> rule('SubmoduleID', 'digit')
						-> rule('SubmoduleName', 'not_empty');
            if($this->post->check()) {
                $result = $this->model->ChangeSubmoduleName($this->user->TeacherID, $this->post['SubmoduleID'], $this->post['SubmoduleName']);
				if ($result[0]['Num'] == 0)
					$data['success'] = true;
            }
			$this->response->body(json_encode($data));
		}
		
		// СВАП порядка двух модулей
		public function action_SwapModuleOrder() {
			$data['success'] = false;
            $this->post -> rule('ModuleID1', 'not_empty')
                        -> rule('ModuleID1', 'digit')
						-> rule('ModuleID2', 'not_empty')
						-> rule('ModuleID2', 'digit');
            if($this->post->check()) {
				$result = $this->model->SwapModuleOrder(
					$this->user->TeacherID,
					$this->post['ModuleID1'],
					$this->post['ModuleID2']
				);
				if ($result[0]['Num'] == 0)
					$data['success'] = true;
			}
			$this->response->body(json_encode($data));
		}
		
		// Свап порядка двух мероприятий
		public function action_SwapSubmoduleOrder(){
			$data['success'] = false;
            $this->post -> rule('SubmoduleID1', 'not_empty')
                        -> rule('SubmoduleID1', 'digit')
						-> rule('SubmoduleID2', 'not_empty')
						-> rule('SubmoduleID2', 'digit');
            if($this->post->check()) {
				$result = $this->model->SwapSubmoduleOrder(
					$this->user->TeacherID,
					$this->post['SubmoduleID1'],
					$this->post['SubmoduleID2']
				);
				if ($result[0]['Num'] == 0)
					$data['success'] = true;
            }
            $this->response->body(json_encode($data));
		}
		
		// Удалить модуль и его мероприятия
		public function action_DeleteModule() {
			$data['success'] = false;
            $this->post -> rule('ModuleID', 'not_empty')
                        -> rule('ModuleID', 'digit');
            if($this->post->check()) {
                $result = $this->model->deleteModule(
					$this->user->TeacherID,
					$this->post['ModuleID']
				);
				$data['success'] = ($result[0]['Num'] == 0);
            }
            $this->response->body(json_encode($data));
        }
		
		// Удалить мероприятие
		public function action_DeleteSubmodule() {
			$data['success'] = false;
            $this->post -> rule('SubmoduleID', 'not_empty')
                        -> rule('SubmoduleID', 'digit');
            if($this->post->check()) {
                $result = $this->privateDeleteSubmodule($this->post['SubmoduleID']);
				$data['success'] = ($result == 0);
			}
			$this->response->body(json_encode($data));
        }

		public function action_ChangeSubmoduleMaxAndControl() {
			$data['success'] = false;
            $this->post -> rule('SubmoduleID', 'not_empty')
                        -> rule('SubmoduleID', 'digit')
						-> rule('MaxRate', 'not_empty')
						-> rule('ControlType', 'not_empty');
            if($this->post->check()) {
                 $result = $this->model->ChangeSubmoduleMaxAndControl(
					$this->user->TeacherID,
					$this->post['SubmoduleID'],
					$this->post['MaxRate'],
					$this->post['ControlType']
				);
				if ($result[0]['Num'] == 0)
					$data['success'] = true;
            }
			$this->response->body(json_encode($data));
		}
	
		// Прикрепить группу
		public function action_BindGroup() {
			$data['success'] = false;
            $this->post -> rule('DisciplineID', 'not_empty')
                        -> rule('DisciplineID', 'digit')
						-> rule('GroupID', 'not_empty')
						-> rule('GroupID', 'digit');
            if($this->post->check()) {
                $result = $this->model->BindGroup($this->user->TeacherID, $this->post['DisciplineID'], $this->post['GroupID']);
				if ($result[0]['Num'] == 0)
					$data['success'] = true;
				$data['code'] = $result[0]['Num'];			
            }
			$this->response->body(json_encode($data));
		}
	
		// Отсоединить группу
		public function action_UnbindGroup() {
			$data['success'] = false;
            $this->post -> rule('DisciplineID', 'not_empty')
                        -> rule('DisciplineID', 'digit')
						-> rule('GroupID', 'not_empty')
						-> rule('GroupID', 'digit');
            if($this->post->check()) {
                $result = $this->model->UnbindGroup($this->user->TeacherID, $this->post['DisciplineID'], $this->post['GroupID']);
				if ($result[0]['Num'] == 0)
					$data['success'] = true;
            }
			$this->response->body(json_encode($data));
		}
	
		// Прикрепить студента
		public function action_BindStudent() {
			$data['success'] = false;
            $this->post -> rule('StudentID', 'not_empty')
                        -> rule('StudentID', 'digit')
						-> rule('DisciplineID', 'not_empty')
						-> rule('DisciplineID', 'digit');
            if($this->post->check()) {
                $result = $this->model->BindStudent($this->user->TeacherID, $this->post['DisciplineID'], $this->post['StudentID']);
				if ($result[0]['Num'] == 0)
					$data['success'] = true;
            }
			$this->response->body(json_encode($data));
		}
		
		// Отсоединить студента 
		public function action_UnbindStudent() {
			$data['success'] = false;
            $this->post -> rule('StudentID', 'not_empty')
                        -> rule('StudentID', 'digit')
						-> rule('DisciplineID', 'not_empty')
						-> rule('DisciplineID', 'digit');
            if($this->post->check()) {
                $result = $this->model->UnbindStudent($this->user->TeacherID, $this->post['DisciplineID'], $this->post['StudentID']);
				if ($result[0]['Num'] == 0)
					$data['success'] = true;
            }
			$this->response->body(json_encode($data));
		}
		
		// Получаем список групп
		public function action_GetGroups() {
			$this->post -> rule('GradeID', 'digit')
						-> rule('FacultyID', 'digit');
			if($this->post->check()) {
                $grade = $this->post['GradeID'];
                $faculty = $this->post['FacultyID'];
				$groups = Model_Faculty::with($faculty)->getGroups($grade);
            }
            $this->response->body(json_encode($groups));
		}
		
		// Поиск студентов
 		public function action_SearchStudents() {
			# TODO: bad post response

			$this->post -> rule('GradeID', 'digit')
						-> rule('GroupID', 'digit')
						-> rule('FacultyID', 'digit')
						-> rule('DisciplineID', 'not_empty')
						-> rule('DisciplineID', 'digit');
			if($this->post->check()) {	
				$searchResult = Model_Students::NotAttendingDiscipline(
					$this->post['GradeID'],
					$this->post['GroupID'],
					$this->post['FacultyID'],
					$this->post['Name'],
					$this->post['DisciplineID']
				);
			}
            $this->response->body(json_encode($searchResult));
		}
		
		// Отсоединить преподавателя 
		public function action_UnbindTeacher() {
			$data['success'] = false;
            $this->post -> rule('BindingTeacher', 'not_empty')
                        -> rule('BindingTeacher', 'digit')
						-> rule('DisciplineID', 'not_empty')
						-> rule('DisciplineID', 'digit');
            if($this->post->check()) {
                $result = $this->model->UnbindTeacher($this->user->TeacherID, $this->post['BindingTeacher'], $this->post['DisciplineID']);
				if ($result[0]['Num'] == 0)
					$data['success'] = true;
            }
			$this->response->body(json_encode($data));
		}

		// Получаем список кафедр 
		public function action_GetDepartments() {
            $this->post -> rule('FacultyID', 'not_empty')
                        -> rule('FacultyID', 'digit');
            if($this->post->check()) {
                $faculty = $this->post['FacultyID'];
                $departments = Model_Departments::byFaculty($faculty);
            }
			$this->response->body(json_encode($departments));
		}
		
		// Поиск преподавателей
		public function action_SearchTeachers() {
			$this->post -> rule('DepartmentID', 'digit')
						-> rule('DisciplineID', 'not_empty')
						-> rule('DisciplineID', 'digit');
			if($this->post->check()) {
				$SeResult = $this->model->SearchTeachers(
					$this->post['FacultyID'],
					$this->post['DepartmentID'],
					$this->post['Last'],
					$this->post['DisciplineID']
				); 
				$SearchResult = array();
				$i = 0;
				foreach($SeResult as $row){
					$i++;
					$SearchResult[$i]['TeacherID'] = $row['ID'];
					$SearchResult[$i]['TeacherLast'] = $row['LastName'];
					$SearchResult[$i]['TeacherFirst'] = $row['FirstName'];
					$SearchResult[$i]['TeacherSecond'] = $row['SecondName'];
					$SearchResult[$i]['JobPositionName'] = $row['JobPositionName'];
					$SearchResult[$i]['DepID'] = $row['DepID'];
				}
				
			}
			$this->response->body(json_encode($SearchResult));
		}
}
